#extension GL_ARB_draw_buffers : enable

uniform sampler2D Texture0;
uniform sampler2D normalMap;

//varying vec4 element2;
varying vec4 position;

varying mat3 normalMatrix;

void main (void) 
{	
	// Make Texture lookup. Combine Texture-Color with vertex color.
	// Pack resulting color and emission-value 0 into buffer1.
	gl_FragData[0] = vec4(texture2D(Texture0,gl_TexCoord[0]).xyz*gl_Color.xyz,gl_Color.w);
	
	// Multiply normal with shininess.
	// Pack combined normal/shininess and depth into buffer2.
	gl_FragData[1] = vec4(normalize(normalMatrix * texture2D(normalMap, gl_TexCoord[0]).xyz)* gl_FrontMaterial.shininess, position.z);
	//gl_FragData[1] = vec4(normalize(normalMatrix * vec3(0,0,1))* gl_FrontMaterial.shininess, position.z);
	gl_FragData[2] = position;
    
}
