#version 110

varying vec2 windowCoord;
varying float wOffset;
varying float wZfactor;

uniform int lightNumber;
uniform sampler2D buffer1;
uniform sampler2D buffer2;
uniform sampler2D buffer3;

vec4 element1;
vec4 element2;
vec4 color;
vec3 normal;
vec4 position;
float depth;
float shininess;
float emission;

void addLightToFragment (void)
{
	vec3 light = normalize(gl_LightSource[0].position.xyz - position.xyz);
	vec3 half = normalize(light+normalize(-position.xyz));
	
	gl_FragColor = color*gl_LightSource[0].ambient;
	
	float angle = dot(light, normal);
	
	angle = clamp(angle,0.0,1.0);
	
	gl_FragColor += angle*color*gl_LightSource[0].diffuse;
	
	angle = dot(half, normal);
	
	angle = clamp(angle,0.0,1.0);
	
	gl_FragColor += pow(angle,shininess)*0.5*gl_LightSource[0].specular;
}

void main (void)
{
	element2 = texture2D(buffer2, gl_TexCoord[0].xy);
	
	if (element2.xyz == vec3(0))
		discard;
		
	shininess = length(element2.xyz);
	normal = normalize(element2.xyz);
	depth = element2.w;
		
	element1 = texture2D(buffer1, gl_TexCoord[0].xy);
	emission = element1.a;
	color = vec4(element1.rgb,0);
	
//	float w = (depth*wZfactor+wOffset);
//	position = gl_ProjectionMatrixInverse * vec4(windowCoord*w, depth, w);
//	position = vec4(position.xyz/position.w,1);

	position = texture2D(buffer3, gl_TexCoord[0].xy);
	addLightToFragment();
}


